﻿/*
 * Created by SharpDevelop.
 * User: jt
 * Date: 29-10-2010
 * Time: 20:38
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Windows.Forms;
using System.Text;
using System.IO;
using System.Drawing;
using System.IO.IsolatedStorage;
using System.Xml.Serialization;
namespace HovText
{
	
	public enum HKFUNCTION
	{
		ACTIVATE_DEACTIVATE,
		REMOVE_FMT
	}
	
	
	/// <summary>
	/// Description of Settings.
	/// </summary>
	public sealed class Settings
	{
		private static Settings instance = null;
		private bool FirstRun = false;
		private static string GetAppFolder()
		{
			string appfolder=Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData);
			appfolder += "\\HovText";
			if (!Directory.Exists(appfolder))
				Directory.CreateDirectory(appfolder);
			appfolder +="\\";
			return appfolder;
			

		}
		
		
		public static Settings Instance {
			get {
				if (instance ==null)
					Load();
				return instance;
			}
		}
		private Settings()
		{
		}
		
		
		private static void Load()
		{
			try{
			   XmlSerializer deserializer = new XmlSerializer(typeof(Settings));
			   using (FileStream fs = new FileStream( GetAppFolder() + "settings.xml", FileMode.Open))
			   {
				   TextReader textReader = new StreamReader(fs, Encoding.UTF8);
				   instance = (Settings)deserializer.Deserialize(textReader);
			   }
			} catch (Exception )
			{
				instance = new Settings();
				instance.FirstRun = true;
				instance.HistorySize = 25;
				instance.RemoveWhiteSpace = true;
			}
			if (instance.LangCode == null)
				instance.LangCode ="";
			if (instance.HistoryBoxWidth < 25)
				instance.HistoryBoxWidth = 400;
			if (instance.HistoryBoxHeight <20)
				instance.HistoryBoxHeight = 250;
			
			if (string.IsNullOrEmpty(instance.FontName))
				instance.Font = new Font("Microsoft Sans Serif", 8);
			instance.Font = new Font(instance.FontName, instance.FontSize, instance.FontStyle);
			if (instance.MainHotKey == null)
				instance.MainHotKey = new HotKey();
			if (instance.HistoryHotKey == null)
				instance.HistoryHotKey = new HotKey();
		}
		
		public void Save()
		{
			System.Xml.Serialization.XmlSerializer x = new System.Xml.Serialization.XmlSerializer(typeof(Settings));
			using (FileStream fs = new FileStream( GetAppFolder() + "settings.xml", FileMode.Create))
			{
			    TextWriter textWriter = new StreamWriter(fs, Encoding.UTF8);
				x.Serialize(textWriter, this);
			}
		}
		
		
		public HotKey MainHotKey {get;set;}
		public HKFUNCTION MainHKFunction {get ; set;}
		public bool RemoveWhiteSpace {get; set;}
		public string LangCode {get; set;}
		
		public HotKey HistoryHotKey {get;set;}
		public int HistorySize {get;set;}
		public int HistoryBoxWidth {get;set;}
		public int HistoryBoxHeight {get;set;}
		private Font _Font;
		[XmlIgnore]
		public Font Font 
		{ 	get {return _Font;}
		 	set 
			{
		 		_Font = value;
		 		FontName = _Font.Name;
		 		FontSize= _Font.Size;
		 		FontStyle = _Font.Style;
			}
		}

		public string FontName {get; set;}
		public float FontSize {get; set;}
		public FontStyle FontStyle {get; set; }
		
		public bool StartWithWindows {get; set;}
		
		private bool _CheckForUpdates =true;
		public bool CheckForUpdates 
		{
			get { return _CheckForUpdates; }
			set { _CheckForUpdates = value; }
		}
		public DateTime UpdateReminded { get; set;}

		public bool IsFirstRun()
		{
			return FirstRun;
		}
	
	
	}
}
