﻿/*
 * Created by SharpDevelop.
 * User: jt
 * Date: 23-10-2010
 * Time: 19:06
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Resources;
using System.Reflection;

namespace HovText
{
	/// <summary>
	/// Description of Form1.
	/// </summary>
	public partial class SetupForm : Form
	{
		private WinStart winStart = new WinStart();
		private bool duringSetup =true;
		public SetupForm()
		{
		

			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			Translate();
			
			SetHotKey(hotkeyControl1,Settings.Instance.MainHotKey);
			if (Settings.Instance.MainHKFunction == HKFUNCTION.REMOVE_FMT)
				radioRemoveFmt.Checked = true;
			else
				radioActivate.Checked = true;
			checkRemoveWhiteSpace.Checked = Settings.Instance.RemoveWhiteSpace;
			
			comboLang.SelectedIndex =0;
			int i=1;
			foreach (KeyValuePair<string, string> kvp in Translation.Instance.GetLangList())
			{
				if (Settings.Instance.LangCode.Equals(kvp.Key))
					comboLang.SelectedIndex = i;
				i++;
			}
			SetHotKey(this.hotkeyHistory, Settings.Instance.HistoryHotKey);
			this.comboHistorySize.Text = Settings.Instance.HistorySize.ToString();
			this.comboHistHeight.Text = Settings.Instance.HistoryBoxHeight.ToString();
			this.comboHistWidth.Text = Settings.Instance.HistoryBoxWidth.ToString();
			ShowFont();
			
			this.checkStartWithWindows.Checked = winStart.HasStartup();
			Settings.Instance.StartWithWindows = this.checkStartWithWindows.Checked ;
			if (VersionInfo.Instance.IsAlpha() || VersionInfo.Instance.IsBeta())
			{
				checkUpdates.Checked = true;
				checkUpdates.Enabled = false;
			} else
				checkUpdates.Checked = Settings.Instance.CheckForUpdates;
			duringSetup = false;	
		}
		
		void SetHotKey(HotKeyControl ctrl, HotKey hk)
		{
			ctrl.Key = hk.KeyCode;
			ctrl.AltKey = hk.Alt;
			ctrl.ControlKey = hk.Control;
			ctrl.ShiftKey = hk.Shift;
			ctrl.WindowsKey = hk.Windows;
		}
		
		HotKey GetHotKey(HotKeyControl ctrl)
		{
			return 
				new HotKey()
					{
					KeyCode = ctrl.Key,
					Alt = ctrl.AltKey,
					Control = ctrl.ControlKey,
					Shift = ctrl.ShiftKey,
					Windows = ctrl.WindowsKey,					
					};
		}

		
		void Translate()
		{
			if (!this.DesignMode)
			{
				Control[] totranslate = new Control[] {buttonCancel, buttonFont, buttonOK, checkRemoveWhiteSpace,
														checkStartWithWindows, checkUpdates, groupBoxHisLook,
														groupBoxHotkeyFunc, groupBoxMisc, groupBoxSize, labelFont, labelHeight,
														labelHistSize, groupBoxHistHotKey, groupBoxHotkeybehavior,
														labelItemsInHistory, labelWidth, labelWidth, labelLanguage,
														radioActivate, radioRemoveFmt, tabPageGeneral,
														tabPageHist,labelHelp,labelHelp2};
				foreach (Control ctl in totranslate)
				{
					if (ctl.Tag ==null)
						ctl.Tag = ctl.Text;
					ctl.Text = ((string)ctl.Tag).GT();
				}
				comboLang.Items.Clear();
				if (this.DesignMode)
					comboLang.Items.Add("Automatic");
				else
					comboLang.Items.Add("Automatic".GT());
				comboLang.SelectedIndex =0;
				foreach (KeyValuePair<string, string> kvp in Translation.Instance.GetLangList())
					comboLang.Items.Add(kvp.Value);
				
				this.Text                = "Settings".GT();
			}
	
		}
		
		void Button1Click(object sender, System.EventArgs e)
		{
			
			Settings.Instance.MainHotKey = GetHotKey(hotkeyControl1);
			if (radioRemoveFmt.Checked)
				Settings.Instance.MainHKFunction = HKFUNCTION.REMOVE_FMT;
			else
				Settings.Instance.MainHKFunction = HKFUNCTION.ACTIVATE_DEACTIVATE;
			Settings.Instance.RemoveWhiteSpace =checkRemoveWhiteSpace.Checked;
			Settings.Instance.LangCode = "";
			foreach (KeyValuePair<string, string> kvp in Translation.Instance.GetLangList())
			{
				if (comboLang.Text.Equals(kvp.Value))
					Settings.Instance.LangCode = kvp.Key;
			}
			Translation.Instance.SetLang(Settings.Instance.LangCode);

			Settings.Instance.HistoryHotKey = GetHotKey(this.hotkeyHistory);
			int val;
			if (Int32.TryParse(this.comboHistorySize.Text, out val))
				Settings.Instance.HistorySize = val;
			if (Int32.TryParse(this.comboHistHeight.Text, out val))
				Settings.Instance.HistoryBoxHeight = val;
			if (Int32.TryParse(this.comboHistWidth.Text, out val))
				Settings.Instance.HistoryBoxWidth = val;
			
			Settings.Instance.CheckForUpdates = checkUpdates.Checked;
			
			if (this.checkStartWithWindows.Checked != Settings.Instance.StartWithWindows)
			{
				Settings.Instance.StartWithWindows =this.checkStartWithWindows.Checked;
				if (this.checkStartWithWindows.Checked )
					winStart.InstallStartup();
				else
					winStart.RemoveStartup();
			}
			
			this.DialogResult = DialogResult.OK;
			this.Close();
		}
		
		void ShowFont()
		{
			richTextBox1.Text = Settings.Instance.Font.Name + ",  " + Settings.Instance.FontSize.ToString();
			richTextBox1.SelectAll();
			richTextBox1.SelectionFont = Settings.Instance.Font;
		}
		
		void Button2Click(object sender, EventArgs e)
		{
			Translation.Instance.SetLang(Settings.Instance.LangCode);
			this.DialogResult = DialogResult.Cancel;
			this.Close();
		}
		
		
		void ButtonFontClick(object sender, EventArgs e)
		{
			fontDialog1.Font = Settings.Instance.Font;
			if (fontDialog1.ShowDialog(this) == DialogResult.OK)
			{
				Settings.Instance.Font = fontDialog1.Font;
				ShowFont();
			}
		}
		
		void ComboLangDropDownClosed(object sender, EventArgs e)
		{
			if (duringSetup)
				return;
			int index = comboLang.SelectedIndex;
			
			string newcode ="";
			foreach (KeyValuePair<string, string> kvp in Translation.Instance.GetLangList())
			{
				if (comboLang.Text.Equals(kvp.Value))
					newcode = kvp.Key;
			}
			Translation.Instance.SetLang(newcode);
			Translate();
			comboLang.SelectedIndex = index;
		}
		
		
		
		void LinkLabel2LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start("http://hovtext.com/?page=documentation");
		}
		
		
	}
}
